# $OpenLDAP: pkg/ldap/build/lib-shared.mk,v 1.13 2000/10/09 18:46:33 kurt Exp $
## Copyright 1998-2000 The OpenLDAP Foundation
## COPYING RESTRICTIONS APPLY.  See COPYRIGHT File in top level directory
## of this package for details.
##*****************************************************************************
##  Copyright (c) 2006 Novell, Inc.
##  All Rights Reserved.
##
##  This library is free software; you can redistribute it and/or
##  modify it under the terms of the GNU Lesser General Public License as
##  published by the Free Software Foundation; version 2.1 of the license.
##
##  This library is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this library; if not, contact Novell, Inc.
##
## To contact Novell about this file by physical or electronic mail,
##  you may find current contact information at www.novell.com
##
##****************************************************************************
##
## Makefile Template for Shared Libraries
##

NT_LTFLAGS = --only-$(LINKAGE)
LTFLAGS = $(@PLAT@_LTFLAGS) 
LFLAG = @LFLAG@

NT_DYN_LT_NO_UNDEF = -no-undefined
LT_NO_UNDEF = $(@PLAT@_@LIB_LINKAGE@_LT_NO_UNDEF)

COMPILE = $(LIBTOOL) $(LTFLAGS) --mode=compile $(CC) $(CFLAGS) $(EXTRA_DEFS) -c
LTLIBLINK = $(LIBTOOL) $(LTFLAGS) --mode=link $(CC) -rpath $(libdir) \
	$(CFLAGS) $(SO_LDFLAGS) $(LDFLAGS) $(LTVERSION) $(LT_NO_UNDEF)

MKDEPFLAG = -l

.SUFFIXES: .c .o .lo

.c.lo:
	$(COMPILE) $<


# DYN_EXT (@DYN_EXT@) describes the extension assoicated with a
# dynamic library, e.g. so, dll

DYN_EXT=@DYN_EXT@

$(LIBRARY):  version.lo
	$(LTLIBLINK) -o $@ $(OBJS) version.lo $(EXTRA_LIBS)
	if test "$(LINK_BINS_DYNAMIC)" = "no"; then \
		$(RM) ../$@ \
		d=`$(PWD)`; d=`$(BASENAME) $$d`; cd ..; $(LN_S) $$d/$@ $@; \
		t=`$(BASENAME) $@ .la`.a; $(RM) $$t; $(LN_S) $$d/.libs/$$t $$t; \
	fi
	if test "$(LINK_BINS_DYNAMIC)" = "yes"; then \
		d=`$(PWD)`; d=`$(BASENAME) $$d`; b=`$(BASENAME) $@ .la`; \
		 cd .libs; t=`echo $$b*.$(DYN_EXT)`; (cd ../.. ; $(RM) $$t; \
		 $(LN_S) $$d/.libs/$$t $$t); \
		if test "$(DYN_EXT)" != dll; then \
		    t=`echo $$b.$(DYN_EXT).?`; cd ../.. ; \
		    $(RM) $$t; \
		    $(LN_S) $$d/.libs/$$t $$t; \
		fi \
	fi

Makefile: $(top_srcdir)/build/lib-shared.mk

