/* $Novell: ssl_io.h,v 1.12 2002/09/18 21:39:53 $
 ******************************************************************************
 * Copyright (c) 2006 Novell, Inc.
 * All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; version 2.1 of the license.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, contact Novell, Inc.
 *
 * To contact Novell about this file by physical or electronic mail,
 * you may find current contact information at www.novell.com
 *
 *****************************************************************************
 * Copyright (C) 1999, 2000 Novell, Inc. All Rights Reserved.
 * 
 * THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
 * TREATIES. USE, MODIFICATION, AND REDISTRIBUTION OF THIS WORK IS SUBJECT
 * TO VERSION 2.0.1 OF THE OPENLDAP PUBLIC LICENSE, A COPY OF WHICH IS
 * AVAILABLE AT HTTP://WWW.OPENLDAP.ORG/LICENSE.HTML OR IN THE FILE "LICENSE"
 * IN THE TOP-LEVEL DIRECTORY OF THE DISTRIBUTION. ANY USE OR EXPLOITATION
 * OF THIS WORK OTHER THAN AS AUTHORIZED IN VERSION 2.0.1 OF THE OPENLDAP
 * PUBLIC LICENSE, OR OTHER PRIOR WRITTEN CONSENT FROM NOVELL, COULD SUBJECT
 * THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY. 
 *****************************************************************************/


/****************************************************************************
*
* Description:   header file for SSL io routine prototypes
*
****************************************************************************/

#if !defined(SSL_IO_H)
#define SSL_IO_H


#ifdef __cplusplus
extern "C" {
#endif

LDAP_F(int) iof_read
(
   ber_socket_t s,
   void         *buf,
   ber_len_t    len,
   LDAP         *ld
);

LDAP_F(int) iof_write
(
   ber_socket_t s,
   void         *buf,
   ber_len_t    len,
   LDAP         *ld
);

LDAP_F(int) iof_select
(
   int            nfds,
#ifdef HAVE_POLL  
   struct pollfd *readfds,  
#else
   fd_set         *readfds,
#endif
   fd_set         *writefds,
   fd_set         *exceptfds,
   struct timeval *timeout,
   LDAP           *ld
);

LDAP_F(ber_socket_t) iof_socket
(
   int af,
   int type,
   int protocol,
   LDAP *ld
);

LDAP_F(int) iof_ioctl
(
   ber_socket_t s,
   long         cmd,
   void         *argp,
   LDAP         *ld
);

LDAP_F(int) iof_connect
(
   ber_socket_t    s,
   struct sockaddr *name,
   int             namelen,
   LDAP            *ld
);

LDAP_F(int) iof_close
(
   ber_socket_t s,
   LDAP         *ld
);

LDAP_F(int) iof_prepare
(
   ber_socket_t s,
   LDAP         *ld
);


LDAP_F(int) iof_no_prepare
(
   ber_socket_t s,
   LDAP         *ld
);

SSL *ldapssl_Get_Handle
( 
   ber_socket_t s
);

void ldapssl_Set_Handle
( 
   ber_socket_t s,
   SSL *hSSL
);


#ifdef __cplusplus
}
#endif

#endif /* !defined(SSL_IO_H) */







